%clear all
%close all
function SimpleExample

%EXAMPLE: Parallel system




%{
%_______________________________________________________________________
%CREATE MASSES AND RULES 
%%define variables and frame
[nf,F,nv,V]=SimpleExampleFrame
%%insert input beliefs
[M,nm,rule,nir]=input_belief(F,V,'SimpleExample_mat',0);
load SimpleExample_mat M nm rule nir
%%insert time updating fot the beliefs
%[Mi,nmi,rulei,niri]=input_belief(F,V,'time_updating_seq',1);
save SimpleExample_mat nf F nv V nm M rule nir
%}




%basic INPUT 
load SimpleExample_mat %nf F nv V nm M rule nir


%%%%%%%%%%
codeV={'s'; 'r' ; 't'};
%Decision variables
nd=1;
D(1).name='s';
D(1).cod=1;
%Elimination sequence
Delta=[2 3]; 
nm_in=nm;


%_______________________________________________________________________
%BUILD BINARY JOINT TREE
Npsi=1:nm; %%initial set of nodes
strategy=1; %heuristic to find an elimination sequence
            %strategy=0 no heuristic (it uses Delta)
            %strategy=1 simpler heuristic
            %strategy=2 this heuristic takes into account of the number of
            %           focal elements
%Binary Join Tree initialization
BJT.n=0;
for i=1:nm
    BJT.n=BJT.n+1; %number of nodes
    BJT.node(BJT.n).father=0; %father pointer
    BJT.node(BJT.n).lson=0;   %left son pointer
    BJT.node(BJT.n).rson=0;   %right son pointer
    BJT.node(BJT.n).dom=M(i).v; %domain
end
[BJT, M, nm, Nn, Del_order]=construct_binary_join_tree(BJT, Npsi, Delta, M, nm, F, V, strategy);
visit_tree(BJT,codeV); %plot the tree
%_______________________________________________________________________


saveas(1, 'BJT', 'fig');


%_______________________________________________________________________
%INWARD PROPAGATION WITH TIME UPDATING
Ms=[];
nmi=0;

%%%%%%%seq=[12; 19; 17; 19; 18; 16; 14; 13];
for new_inf=0:nmi
    tic
    new_inf
    updated_inputs=Npsi; %see inside inward function for an explanation
    stage=0; %see inside inward function for an explanation
    if new_inf>0
        for k=1:nm_in
            if length(Mi(new_inf).v)==length(M(k).v) & length(find((M(k).v==Mi(new_inf).v)))==length(Mi(new_inf).v)
                Ms(k)=Mi(new_inf);
                M(k)=Mi(new_inf);
                stage=1;
            else
                updated_inputs=setdiff(updated_inputs, k);
            end
        end
    end

    %Inward propagation
    [Mroot(new_inf+1).m, M, Ms]=inward(BJT,M,nm,Nn,F,V,D,updated_inputs,stage, Ms);
    toc
end

%_______________________________________________________________________
%Belief and Plausibility
figure(2)
BelRoot = Bel(Mroot.m);
PlausRoot = Plaus(Mroot.m);
bar1=bar([0.9:1:1.9], BelRoot, 'BarWidth',0.2,'FaceColor','b');
hold on;
bar2=bar([1.1:1:2.1], PlausRoot, 'BarWidth',0.2,'FaceColor','c');
legend('Belief','Plausibility');
axis([0 3 0 1]);
xlabel('System');
title('Belief and Plausibility');
saveas(2, 'BelPl', 'fig');

%_______________________________________________________________________
%OUTPUT: MASSES and Pignistic transf.
figure(3)
fd=[0:3];
fid = fopen('results.txt','w');
for new_inf=0:nmi
    fprintf(fid,'%s\n',['TIME=' num2str(new_inf)]);
    fprintf(fid,'\n');
    fprintf(fid,'%s\n','BBM(THREAT)= (focal element) -> mass');
    %fprintf(fid,'%s\n','(focals) -> mass');
    for i=1:Mroot(new_inf+1).m.num_focal
        stry=['(' num2str([Mroot(new_inf+1).m.foc(i).elem]-ones(1,length(Mroot(new_inf+1).m.foc(i).elem))) ')' '->' num2str(Mroot(new_inf+1).m.foc(i).mass)];
        fprintf(fid,'%s\n',stry);
        BetP_decision(new_inf+1).b = pign(Mroot(new_inf+1).m);
    end
    fprintf(fid,'\n');
    fprintf(fid,'\n');
    fprintf(fid,'%s\n',['PIGNISTIC TRASF.']);
    fprintf(fid,'%3s\n',['focals=' num2str([1:2])]);
    fprintf(fid,'%s\n',['Prob=' num2str(BetP_decision(new_inf+1).b)]);
    subplot(max(1,floor(nmi/2)),max(1,ceil(nmi/max(1,floor(nmi/2)))),new_inf+1);
    %axis([fd(1) fd(11) 0 0.5]);
        set(gca,'FontSize',14)
        set(gca,'XLim',[0.5 2.5])
    title(['t_' num2str(new_inf)])
    set(gca,'YLim',[0 1.05])
    xlabel('System')
    ylabel('prob')
    hold on
    bar([1:2],BetP_decision(new_inf+1).b);
    fprintf(fid,'\n');
    fprintf(fid,'\n');
    fprintf(fid,'\n');
    fprintf(fid,'-------------------------------------------------\n');
end
%


saveas(3, 'Proba', 'fig');
fclose(fid);

%_______________________________________________________________________




%{
%_______________________________________________________________________
%%OUTWARD PROPAGATION
Mo=outward(BJT,Mo,nm,Nn,F,V,D)
%_______________________________________________________________________

for i=1:nm
    disp(['node=' num2str(i)]);
     disp(['var=' num2str(Mo(i).v)]);
     Pign(i).p=[Mo(i).matrix (pign(Mo(i)))'];
     disp([num2str(Pign(i).p)]);
end

%}


%SENSITIVITY ANALYSIS
%_______________________________________________________________________

%sens_analysis(BJT,M,nm,Nn,F,V,D,13)



%_______________________________________________________________________


