function [M,nm,rule,nir]=input_belief_new(F,V,fileMATname,upd_time)

%input_belief: interface to create the initial bbm from the rule and from
%the joint beliefs
%
%[M,nm,rule,nir]=input_belief(nm,nir,F,V) returns the structures M (bbm) and rule
%
%
%INPUT:
% F=frames
% V=variables
%OUTPUT:
% M=bbm
% rule=rules
% nm=num of beliefs
% nir=num of rules
fidReadData=fopen('inputdata.txt');                                 
           

%Qiu's comment% num_val=str2num(input('Insert the number of the beliefs ', 's'));
num_val=str2num(fgetl(fidReadData));

rule=[];
vir=0;
nm=0;
for nv=1:num_val
    %Qiu's comment% fprintf('%d\n',nv);
    %Qiu's comment% opz=str2num(input('Joint belief or rule: 1 o 2 ', 's'));
    opz=str2num(fgetl(fidReadData));
    if opz==2
        %Create Joint Belief from implication rule
        vir=vir+1;
        %Qiu's comment% rule(vir).antec_var=str2num(input('antecedent variable: ', 's'));
        %Qiu's comment% rule(vir).antec_val=str2num(input('value: ', 's'));
        %Qiu's comment% rule(vir).conseq_var=str2num(input('conseqent variable: ', 's'));
        %Qiu's comment% num_cons=str2num(input('num of conseq.: ', 's'));
        rule(vir).antec_var=str2num(fgetl(fidReadData));
        rule(vir).antec_val=str2num(fgetl(fidReadData));
        rule(vir).conseq_var=str2num(fgetl(fidReadData));
        num_cons=str2num(fgetl(fidReadData));
%         rule(vir).conseq=[];
%         rule(vir).mass=[];
%         rule1=rule(vir);
%         for c=1:num_cons
%             rule1.conseq(c).val=str2num(input('value: ', 's'));
%             rule1.mass(c).v=str2num(input('Insert mass for this rule: ','s'));
%             rule(vir)=rule1;
%             nm=nm+1;
%             M(nm)=rule2bbm(rule(vir),c,F,V);
%             save(fileMATname, 'M', 'nm', 'rule', 'vir');
%             vir=vir+1;
%         end
        for c=1:num_cons
            %Qiu's comment% rule(vir).conseq(c).val=str2num(input('value: ', 's'));
            %Qiu's comment% rule(vir).mass(c).v=str2num(input('Insert mass for this rule: ','s'));
            rule(vir).conseq(c).val=str2num(fgetl(fidReadData));
            rule(vir).mass(c).v=str2num(fgetl(fidReadData));
        end
        nm=nm+1;
        M(nm)=rule2bbm(rule(vir),num_cons,F,V);
        save(fileMATname, 'M', 'nm', 'rule', 'vir');
    else
        % %Create Joint Belief
        nm=nm+1;
        %Qiu's comment% M(nm).v=sort(str2num(input('Joint Belief -> insert variables for this belief: ', 's')));%% %variables
        M(nm).v=sort(str2num(fgetl(fidReadData)));%% %variables
        num_v=size(M(nm).v,2); %num variables
        M(nm).nv=num_v;%%

        card=[];
        pcard=[];
        for i=1:num_v
            card=[card F(V(M(nm).v(i)).frame).card];
            pcard(i).el=1:card(i);
        end

        M(nm).cartprod=card;%% cardinality of single frames
        M(nm).ne=prod(card);%%cardinality of joint set
        M(nm).matrix=cartprod(pcard(1:num_v).el); %%cartesian product
        %Qiu's comment% M(nm).num_focal=str2num(input('Insert num focal sets: ','s'));%%num focal elements
        M(nm).num_focal=str2num(fgetl(fidReadData));%%num focal elements

        %Qiu's comment% M(nm).matrix

        for fs=1:M(nm).num_focal
            %Qiu's comment% disp('Focal element in this order');
            %Qiu's comment% disp(M(nm).v);
            %Qiu's comment% elem=str2num(input('Insert value es. a b c; d e f; g h i...:  ','s'));
            elem=str2num(fgetl(fidReadData));
            M(nm).foc(fs).num_el=size(elem,1);
            EL=[];
            for i=1:M(nm).foc(fs).num_el
                %%insert function name -> frame
                for j=1:M(nm).ne
                    sf=size(find(M(nm).matrix(j,:)==elem(i,:)),2);
                    if sf==length(M(nm).v)
                        EL=[EL j];
                        break;
                    end
                end
            end
            EL=sort(EL);

            M(nm).foc(fs).elem=EL;%% Elements focal set
            %Qiu's comment% M(nm).foc(fs).mass=str2num(input('Insert mass for this focal set: ','s')); %% mass focal set
            M(nm).foc(fs).mass=str2num(fgetl(fidReadData)); %% mass focal set
            
        end
        mass_tot=0;
        for fs=1:M(nm).num_focal
            mass_tot=mass_tot+M(nm).foc(fs).mass;
        end
        if mass_tot<1 %Sum(mass)=1
            M(nm).num_focal=M(nm).num_focal+1;
            M(nm).foc( M(nm).num_focal).elem=[1:M(nm).ne]; %universe
            M(nm).foc( M(nm).num_focal).num_el=M(nm).ne;
            M(nm).foc( M(nm).num_focal).mass=1-mass_tot;
        end
        save(fileMATname, 'M', 'nm', 'rule', 'vir');
    end
end
%load(fileMATname, 'M', 'nm', 'rule', 'vir', 'nir');
nir=vir-1;
if upd_time==0
    nodeT=[1:nm];
    [M, nm]=find_bba_commDom(nodeT,M,F,V);
    save(fileMATname, 'M', 'nm', 'rule', 'vir','nir');
end

fclose(fidReadData);