function Ms=var_elim(el,M,delta,F,V)

%var_elim: variable elimination
%
%Ms=var_elim(el,M,delta,F,V) returns the bbm after the elimination
%
%
%INPUT:
% el=element of M 
% M=bbm
% delta=new domain
%OUTPUT:
% Ms:new bbm


%evaluate if the domain of the bbm is already delta
equ=0;
if size(M(el).v,2)==size(delta,2)
    if M(el).v==delta
        equ=1;
    end
end

if isempty(delta)==0 & equ==0
    [Ms.v,Ind]=setdiff(M(el).v,delta);
    Ind=sort(Ind);
    num_v=size(Ms.v,2);
    Ms.nv=num_v;
    Ms.cartprod=M(el).cartprod(Ind);
    Ms.ne=prod(Ms.cartprod);
    card=[];
    pcard=[];
    for i=1:num_v
        card=[card F(V(Ms.v(i)).frame).card];
        pcard(i).el=1:card(i);
    end
    Ms.matrix=cartprod(pcard(1:num_v).el);%%cartesian product
    
    Ms.num_focal=0;
    Ms.foc=[];
    %marginalize
    for i=1:M(el).num_focal
        nelem=[];
        for j=1:M(el).foc(i).num_el
            elem=M(el).foc(i).elem(j);
            mat0= M(el).matrix(elem,:);
            mat1=mat0(Ind);%marginalize
            K=[];
            for k=1:Ms.ne
                res=(Ms.matrix(k,:)==mat1);
                if isempty(find(res==0))==1
                    K=k;
                    break;
                end
            end
            nelem=sort([setdiff(nelem,K) K]);
        end
        found_el=0;
        for k=1:Ms.num_focal
            if size(Ms.foc(k).elem,2)==size(nelem,2)
                if isempty(find((Ms.foc(k).elem==nelem)==0))==1
                    found_el=k;
                    break;
                end
            end
        end
        if found_el==0;
            num_focal=Ms.num_focal+1;
            Ms.num_focal=num_focal;
            Ms.foc(num_focal).num_el=0;
            Ms.foc(num_focal).elem=[];
            Ms.foc(num_focal).elem=nelem;
            Ms.foc(num_focal).elem=sort(Ms.foc(num_focal).elem);
            Ms.foc(num_focal).num_el=size( Ms.foc(num_focal).elem,2);
            Ms.foc(num_focal).mass=M(el).foc(i).mass;
        else
            Ms.foc(found_el).mass=Ms.foc(found_el).mass+M(el).foc(i).mass;
        end
    end
else
    Ms=M(el);
end