function Ms=extend(M,comm_dom,card,pcard)

%extend: calculates the vacuos extension of the bbm in input
%
%Ms=extend(M,comm_dom,card,pcard) returns the vacuos extension
%
%INPUT:
% M: bbm
% comm_dom: new domain
% card: cardinality of the new domain
% pcard: cartesian product of the new domain
%OUTPUT:
% Ms=vacuos extension

%evaluate if the domain of the bbm is already comm_dom
equ=0;
if size(M.v,2)==size(comm_dom,2)
    if isempty(find((M.v==comm_dom)==0))==1
        equ=1;
    end
end

vac=0;
if equ==0 %if the domain of the bbm is not comm_dom
    if vac==0
        ind=[];
        for i=1:M.nv
            ef=find(comm_dom==M.v(i)); %find the element of the domain of the bbm that are also in comm_dom
            if isempty(ef)==0
                ind=[ind ef];
            end
        end
        %initialize a new bbm,
        Ms.v=comm_dom;
        num_v=size(comm_dom,2);
        Ms.nv=num_v;
        Ms.cartprod=card;
        Ms.ne=prod(card);
        Ms.matrix=cartprod(pcard(1:num_v).el);
      
        %calculate the mass for the new bbm
        %init
        Ms.num_focal=0;
        Ms.foc=[];
        Mnorm=0;
        for i=1:M.num_focal
            %updating of the new bbm
            num_focal=Ms.num_focal+1;
            Ms.num_focal=num_focal;
            Ms.foc(num_focal).num_el=0;
            Ms.foc(num_focal).elem=[];
            K=[];
            a=1;
            for j=1:M.foc(i).num_el %for each focal set  
                K(a).k=[];
                elem=M.foc(i).elem(j); %get an element of the focal set
                mat0= M.matrix(elem,:); %search the elements in M.matrix containing elem
                for k=1:Ms.ne
                    if isempty(find((Ms.matrix(k,ind)==mat0)==0))==1 %extension
                        K(a).k=[K(a).k k];
                    end
                end
                a=a+1;
            end
            K1=K(1).k;
            for k=2:a-1
                K1=union(K1,K(k).k);
            end
            %insert the masses in the new bbm
            Ms.foc(num_focal).elem=[setdiff(Ms.foc(num_focal).elem,K1) K1];
            Ms.foc(num_focal).elem=sort(Ms.foc(num_focal).elem);
            Ms.foc(num_focal).num_el=size( Ms.foc(num_focal).elem,2);
            Ms.foc(num_focal).mass=M.foc(i).mass;
            Mnorm=Mnorm+M.foc(i).mass;
        end
    else
        Ms.v=comm_dom;
        num_v=size(comm_dom,2);
        Ms.nv=num_v;
        Ms.cartprod=card;
        Ms.ne=prod(card);
        Ms.matrix=cartprod(pcard(1:num_v).el);
        Ms.num_focal=1;
        Ms.foc(1).num_el=Ms.ne;
        Ms.foc(1).elem=1:Ms.ne;
        Ms.foc(1).mass=1;
    end
    %     for i=1:Ms.num_focal
    %         Ms.foc(i).mass=Ms.foc(i).mass/Mnorm;
    %     end
else
    Ms=M;
end
