function Mp=val_prod(Ms1,Ms2,fath_dom,F,V)

%val_prod: combination of two valuations - DS rule
%
%Mp=val_prod(Ms1,Ms2,fath_dom,F,V) returns the combined bbm
%
%
%INPUT:
% Ms1= bbm 1
% Ms2=bbm 2
% fath_dom= domain of the father node in the BJT for Ms1 and Ms2
% F=frames
% V=variables
%OUTPUT:
% Mp=combined bbm

comm_dom=union(Ms1.v,Ms2.v); %common frame
%calculate frame cardinality
num_v=size(comm_dom,2);
card=[];
pcard=[];
%card=3;
for i=1:num_v
    card=[card F(V(comm_dom(i)).frame).card];
    pcard(i).el=1:card(i);
end
%extend MS1 e Ms2 to the common frame
Ms1=extend(Ms1,comm_dom,card,pcard);
Ms2=extend(Ms2,comm_dom,card,pcard);

%Calculate the combined bbm
Mp.v=comm_dom;
Mp.nv=num_v;
Mp.cartprod=card;
Mp.ne=prod(card);
Mp.matrix=cartprod(pcard(1:num_v).el);
%Mp.matrix=Mp.matrix(:,[Mp.nv:-1:1]);

Mp.num_focal=0;
Mp.foc=[];
Mnorm=0;
for i=1:Ms1.num_focal
    for j=1:Ms2.num_focal
        inter=intersect(Ms1.foc(i).elem,Ms2.foc(j).elem);
        if isempty(inter)==0
            found_el=0;
            for k=1:Mp.num_focal
                if size(Mp.foc(k).elem,2)==size(inter(1,:),2)
                    if isempty(find((Mp.foc(k).elem==inter(1,:))==0))==1
                        found_el=k;
                        break;
                    end
                end
            end
            if found_el==0
                Mp.num_focal=Mp.num_focal+1;
                Mp.foc(Mp.num_focal).num_el=size(inter,2); %size(find(comb(c,:)==dec2bin(1)),2);
                Mp.foc(Mp.num_focal).elem=inter(1,:);%inter(1,find(comb(c,:)==dec2bin(1)));
                Mp.foc(Mp.num_focal).mass=Ms1.foc(i).mass*Ms2.foc(j).mass;
                Mnorm=Mnorm+Mp.foc(Mp.num_focal).mass; %normalization constant
            else
                Mp.foc(found_el).mass=Mp.foc(found_el).mass+Ms1.foc(i).mass*Ms2.foc(j).mass;
                Mnorm=Mnorm+Ms1.foc(i).mass*Ms2.foc(j).mass; %normalization constant
            end 
        end
    end
end

%normalization
for i=1:Mp.num_focal
    Mp.foc(i).mass=Mp.foc(i).mass/Mnorm;
end

